Commit 033a52d0 authored by Owen Rafferty's avatar Owen Rafferty Committed by Masahiro Yamada
Browse files

kbuild: rewrite check-local-export in sh/awk



Remove the bash build dependency for those who otherwise do not
have it installed. This also provides a significant speedup:

$ make defconfig
$ make yes2modconfig

...

$ find  .  -name "*.o" | grep -v vmlinux | wc
     3169      3169     89615
$ export NM=nm
$ time sh -c 'find . -name "*.o" | grep -v vmlinux | xargs -n1
./scripts/check-local-export'

Without patch:
    0m15.90s real     0m12.17s user     0m05.28s system

With patch:
dash + nawk
    0m02.16s real     0m02.92s user     0m00.34s system

dash + busybox awk
    0m02.36s real     0m03.36s user     0m00.34s system

dash + gawk
    0m02.07s real     0m03.26s user     0m00.32s system

bash + gawk
    0m03.55s real     0m05.00s user     0m00.54s system

Signed-off-by: default avatarOwen Rafferty <owen@owenrafferty.com>
Signed-off-by: default avatarMasahiro Yamada <masahiroy@kernel.org>
parent a6c26e38
Loading
Loading
Loading
Loading
+48 −49
Original line number Diff line number Diff line
#!/usr/bin/env bash
#!/bin/sh
# SPDX-License-Identifier: GPL-2.0-only
#
# Copyright (C) 2022 Masahiro Yamada <masahiroy@kernel.org>
# Copyright (C) 2022 Owen Rafferty <owen@owenrafferty.com>
#
# Exit with error if a local exported symbol is found.
# EXPORT_SYMBOL should be used for global symbols.

set -e

# catch errors from ${NM}
set -o pipefail

# Run the last element of a pipeline in the current shell.
# Without this, the while-loop would be executed in a subshell, and
# the changes made to 'symbol_types' and 'export_symbols' would be lost.
shopt -s lastpipe

declare -A symbol_types
declare -a export_symbols

exit_code=0
pid=$$

# If there is no symbol in the object, ${NM} (both GNU nm and llvm-nm) shows
# 'no symbols' diagnostic (but exits with 0). It is harmless and hidden by
@@ -29,12 +18,15 @@ exit_code=0
# TODO:
# Use --quiet instead of 2>/dev/null when we upgrade the minimum version of
# binutils to 2.37, llvm to 13.0.0.
# Then, the following line will be really simple:
#   ${NM} --quiet ${1} |
# Then, the following line will be simpler:
#   { ${NM} --quiet ${1} || kill 0; } |

{ ${NM} ${1} 2>/dev/null || { echo "${0}: ${NM} failed" >&2; kill $pid; } } |
${AWK} -v "file=${1}" '
BEGIN {
	i = 0
}

{ ${NM} ${1} 2>/dev/null || { echo "${0}: ${NM} failed" >&2; false; } } |
while read value type name
do
# Skip the line if the number of fields is less than 3.
#
# case 1)
@@ -44,28 +36,35 @@ do
#   It is unneeded to record undefined symbols.
#
# case 2)
	#   For Clang LTO, llvm-nm outputs a line with type 't' but empty name:
#   For Clang LTO, llvm-nm outputs a line with type t but empty name:
#     "---------------- t"
	if [[ -z ${name} ]]; then
		continue
	fi
!length($3) {
	next
}

# save (name, type) in the associative array
	symbol_types[${name}]=${type}
{ symbol_types[$3]=$2 }

# append the exported symbol to the array
	if [[ ${name} == __ksymtab_* ]]; then
		export_symbols+=(${name#__ksymtab_})
	fi
done
($3 ~ /^__ksymtab_/) {
	export_symbols[i] = $3
	sub(/^__ksymtab_/, "", export_symbols[i])
	i++
}

for name in "${export_symbols[@]}"
do
END {
	exit_code = 0
	for (j = 0; j < i; ++j) {
		name = export_symbols[j]
		# nm(3) says "If lowercase, the symbol is usually local"
	if [[ ${symbol_types[$name]} =~ [a-z] ]]; then
		echo "$@: error: local symbol '${name}' was exported" >&2
		if (symbol_types[name] ~ /[a-z]/) {
			printf "%s: error: local symbol %s was exported\n",
				file, name | "cat 1>&2"
			exit_code = 1
	fi
done
		}
	}

	exit exit_code
}'

exit ${exit_code}
exit $?